#!/bin/bash

SAVEIFS=$IFS
IFS=$(echo -en "\n\b")
VERSION=0.1

if (( $# < 1 )) ; then
    cd "$1"
fi
                         
header() {
	 # echo ----------------------------------------------------------
	 echo bpm.sh - adding bpm tag, version $VERSION
	 echo ----------------------------------------------------------
	 echo -ne "\n"
 	}
            
check_bpm-tools() {
	local bpmtagok=$(which bpm-tag)
	if [ -z "$bpmtagok" ]; then
		echo "you need bpm-tag to run this script"
		echo "apt-get install bpm-tools"
                exit 1
	fi
	# checking for eyeD3 ...
        local eyed3ok=$(which eyeD3)

	if [ -z "$eyed3ok" ]; then
		echo "you need eyeD3 (http://eyed3.nicfit.net/) to run this script"
                exit 1
	fi
	}
        echo " all tools found."
                                          
header
while [ "$1" ]; do
	case $1 in
        	-v) exit 0;;
                -c) check_bpm-tools; exit 0;;
                -i) cover_img; exit 0;;
        esac
        shift
done

for d in */ ; do
        echo cleaning up $d
        cd "$d"
	for file in $(find -iname '*.mp3' | sort); do
		echo checking "$file"
		bpmset=$(eyeD3 "$file" |grep BPM |cut -f2 -d':'|cut -f2 -d ' ')
        		if [ -z "$bpmset" ]; then
				echo -n "no bpm tag "
				bpm=$(bpm-tag -f -n "$file" 2>&1 | cut -f2 -d':' | cut -f1 -d '.')
				echo "- set bpm to$bpm"
				eyeD3 --preserve-file-times "$file" --bpm=$bpm &> /dev/null
			else
				echo bpm tag is set to $bpmset
			fi
		echo -ne "\n"
	done
cd ..
done
IFS=$SAVEIFS
